searchNodes=[{"ref":"VistaClient.html","title":"VistaClient","type":"module","doc":"Documentation for VistaClient. Examples iex&gt; {:ok, cinemas} = VistaClient.get_cinemas() iex&gt; cinemas |&gt; Enum.find(fn cinema -&gt; cinema.id == 1001 end) %VistaClient.Cinema{id: 1001, name: &quot;Delphi Lux&quot;}"},{"ref":"VistaClient.html#add_concession/3","title":"VistaClient.add_concession/3","type":"function","doc":""},{"ref":"VistaClient.html#add_variable_price_concession/4","title":"VistaClient.add_variable_price_concession/4","type":"function","doc":""},{"ref":"VistaClient.html#complete_order/4","title":"VistaClient.complete_order/4","type":"function","doc":""},{"ref":"VistaClient.html#extract_payload_parameters/2","title":"VistaClient.extract_payload_parameters/2","type":"function","doc":"Extracts and validates parameters from opts list for use with make_payload Examples iex&gt; VistaClient.extract_payload_parameters(:validate_member, user_session_id: :atom, member_card_number: 23) {:error, {:invalid, [user_session_id: :atom]}} iex&gt; VistaClient.extract_payload_parameters(:validate_member, user_session_id: &quot;123&quot;, member_card_number: &quot;555123456&quot;) {:ok, [member_card_number: &quot;555123456&quot;, user_session_id: &quot;123&quot;]} iex&gt; VistaClient.extract_payload_parameters(:add_concessions, user_session_id: &quot;test&quot;, cinema_id: &quot;007&quot;, head_office_item_code: &quot;666&quot;) {:ok, [user_session_id: &quot;test&quot;, cinema_id: &quot;007&quot;, head_office_item_code: &quot;666&quot;, variable_price: nil]} iex&gt; VistaClient.extract_payload_parameters(:add_concessions, user_session_id: &quot;000&quot;, head_office_item_code: &quot;aaa&quot;, cinema_id: &quot;123&quot;, variable_price: 500) {:ok, [user_session_id: &quot;000&quot;, cinema_id: &quot;123&quot;, head_office_item_code: &quot;aaa&quot;, variable_price: 500]} iex&gt; VistaClient.extract_payload_parameters(:start_external_payment, user_session_id: &quot;777&quot;) {:ok, [user_session_id: &quot;777&quot;]} iex&gt; VistaClient.extract_payload_parameters(:complete_order, user_session_id: &quot;1&quot;, customer_email: &quot;foo@bar.baz&quot;, payment_value: 2500, pament_reference: &quot;1nc19-832-a83uhd&quot;) {:error, {:invalid, [payment_reference: nil]}} iex&gt; VistaClient.extract_payload_parameters(:complete_order, user_session_id: &quot;1&quot;, customer_email: &quot;foo@bar.baz&quot;, payment_value: 2500, payment_reference: &quot;1nc19-832-a83uhd&quot;) {:ok,[user_session_id: &quot;1&quot;, customer_email: &quot;foo@bar.baz&quot;, payment_value: 2500, payment_reference: &quot;1nc19-832-a83uhd&quot;]}"},{"ref":"VistaClient.html#get/2","title":"VistaClient.get/2","type":"function","doc":"Performs a HTTP-GET request and decodes the JSON response into a struct. Returns {:ok, }. Options: :output_raw_maps =&gt; set to true to get plain decoded JSON map"},{"ref":"VistaClient.html#get_cinemas/0","title":"VistaClient.get_cinemas/0","type":"function","doc":"Callback implementation for VistaClient.Behaviour.get_cinemas/0."},{"ref":"VistaClient.html#get_endpoints/0","title":"VistaClient.get_endpoints/0","type":"function","doc":""},{"ref":"VistaClient.html#get_scheduled_films/0","title":"VistaClient.get_scheduled_films/0","type":"function","doc":"Callback implementation for VistaClient.Behaviour.get_scheduled_films/0."},{"ref":"VistaClient.html#get_session_availabilty/1","title":"VistaClient.get_session_availabilty/1","type":"function","doc":"Callback implementation for VistaClient.Behaviour.get_session_availabilty/1."},{"ref":"VistaClient.html#get_sessions/0","title":"VistaClient.get_sessions/0","type":"function","doc":"Callback implementation for VistaClient.Behaviour.get_sessions/0."},{"ref":"VistaClient.html#make_basic_headers/0","title":"VistaClient.make_basic_headers/0","type":"function","doc":"creates auth and content-type and accept headers"},{"ref":"VistaClient.html#make_payload/2","title":"VistaClient.make_payload/2","type":"function","doc":"Builds a JSON map formatted to receive membership details. If no user_session_id is specified, a temporaray random one will be generated. Examples iex&gt; VistaClient.make_payload(:validate_member, member_card_number: &quot;1234&quot;, user_session_id: &quot;temp_foo&quot;) %{&quot;UserSessionId&quot; =&gt; &quot;temp_foo&quot;, &quot;MemberCardNumber&quot; =&gt; &quot;1234&quot;, &quot;ReturnMember&quot; =&gt; true} iex&gt; VistaClient.make_payload(:start_external_payment, user_session_id: &quot;idontwannapay&quot;) %{&quot;AutoCompleteOrder&quot; =&gt; false, &quot;UserSessionId&quot; =&gt; &quot;idontwannapay&quot;} iex&gt; VistaClient.make_payload(:complete_order, user_session_id: &quot;idontwannapay&quot;, customer_email: &quot;idont@wanna.pay&quot;, payment_value: 1234, payment_reference: &quot;buttheypaidanyway&quot;) %{&quot;BookingType&quot; =&gt; 0, &quot;CustomerEmail&quot; =&gt; &quot;idont@wanna.pay&quot;, &quot;CustomerName&quot; =&gt; &quot;WEBSHOP&quot;, &quot;CustomerPhone&quot; =&gt; &quot;WEBSHOP&quot;, &quot;GenerateConcessionVoucherPrintStream&quot; =&gt; true, &quot;GeneratePrintStream&quot; =&gt; true, &quot;PaymentInfo&quot; =&gt; %{&quot;BankReference&quot; =&gt; &quot;buttheypaidanyway&quot;, &quot;BillFullOutstandingAmount&quot; =&gt; true, &quot;BillingValueCents&quot; =&gt; 1234, &quot;CardType&quot; =&gt; &quot;PAYPAL&quot;, &quot;PaymentValueCents&quot; =&gt; 1234}, &quot;PerformPayment&quot; =&gt; false, &quot;PrintStreamType&quot; =&gt; 1, &quot;PrintTemplateName&quot; =&gt; &quot;www_P@H&quot;, &quot;ReturnPrintStream&quot; =&gt; true, &quot;UserSessionId&quot; =&gt; &quot;idontwannapay&quot;}"},{"ref":"VistaClient.html#make_request/1","title":"VistaClient.make_request/1","type":"function","doc":""},{"ref":"VistaClient.html#make_structs/2","title":"VistaClient.make_structs/2","type":"function","doc":""},{"ref":"VistaClient.html#make_url_for/2","title":"VistaClient.make_url_for/2","type":"function","doc":""},{"ref":"VistaClient.html#make_url_for/3","title":"VistaClient.make_url_for/3","type":"function","doc":""},{"ref":"VistaClient.html#online?/0","title":"VistaClient.online?/0","type":"function","doc":"Returns {:ok, true} if VISTA server seems up {:ok, false} if not {:error, reason} on config error EXAMPLES iex&gt; VistaClient.online?() {:ok, true}"},{"ref":"VistaClient.html#payload_for/2","title":"VistaClient.payload_for/2","type":"function","doc":"Creates JSON post body (a string) to select API endpoints Examples iex&gt; VistaClient.payload_for(:validate_member, member_card_number: 1234, user_session_id: 666) {:ok, &quot;{\\&quot;MemberCardNumber\\&quot;:\\&quot;1234\\&quot;,\\&quot;ReturnMember\\&quot;:true,\\&quot;UserSessionId\\&quot;:\\&quot;666\\&quot;}&quot;} iex&gt; VistaClient.payload_for(:add_concessions, user_session_id: &quot;me&quot;, head_office_item_code: &quot;2019&quot;) {:error, {:missing, :cinema_id}} iex&gt; VistaClient.payload_for :add_concessions, user_session_id: &quot;abc&quot;, cinema_id: &quot;123&quot;, head_office_item_code: &quot;XYZ&quot; {:ok, &quot;{\\&quot;CinemaId\\&quot;:\\&quot;123\\&quot;,\\&quot;Concessions\\&quot;:[{\\&quot;GetBarcodeFromVGC\\&quot;:true,\\&quot;HeadOfficeItemCode\\&quot;:\\&quot;XYZ\\&quot;,\\&quot;Quantity\\&quot;:1}],\\&quot;UserSessionId\\&quot;:\\&quot;abc\\&quot;}&quot;} iex&gt; VistaClient.payload_for :start_external_payment {:error, {:missing, :user_session_id}} iex&gt; VistaClient.payload_for(:start_external_payment, user_session_id: &quot;7357&quot;) {:ok, &quot;{\\&quot;AutoCompleteOrder\\&quot;:false,\\&quot;UserSessionId\\&quot;:\\&quot;7357\\&quot;}&quot;} iex(23)&gt; VistaClient.payload_for(:complete_order, user_session_id: &quot;f00&quot;, customer_email: &quot;customer@e.mail&quot;, payment_value: 1000, payment_reference: &quot;1337&quot;) {:ok, &quot;{\\&quot;BookingType\\&quot;:0,\\&quot;CustomerEmail\\&quot;:\\&quot;customer@e.mail\\&quot;,\\&quot;CustomerName\\&quot;:\\&quot;WEBSHOP\\&quot;,\\&quot;CustomerPhone\\&quot;:\\&quot;WEBSHOP\\&quot;,\\&quot;GenerateConcessionVoucherPrintStream\\&quot;:true,\\&quot;GeneratePrintStream\\&quot;:true,\\&quot;PaymentInfo\\&quot;:{\\&quot;BankReference\\&quot;:\\&quot;1337\\&quot;,\\&quot;BillFullOutstandingAmount\\&quot;:true,\\&quot;BillingValueCents\\&quot;:1000,\\&quot;CardType\\&quot;:\\&quot;PAYPAL\\&quot;,\\&quot;PaymentValueCents\\&quot;:1000},\\&quot;PerformPayment\\&quot;:false,\\&quot;PrintStreamType\\&quot;:1,\\&quot;PrintTemplateName\\&quot;:\\&quot;www_P@H\\&quot;,\\&quot;ReturnPrintStream\\&quot;:true,\\&quot;UserSessionId\\&quot;:\\&quot;f00\\&quot;}&quot;}"},{"ref":"VistaClient.html#post/3","title":"VistaClient.post/3","type":"function","doc":""},{"ref":"VistaClient.html#post_request/2","title":"VistaClient.post_request/2","type":"function","doc":""},{"ref":"VistaClient.html#quickcheck_email_address/1","title":"VistaClient.quickcheck_email_address/1","type":"function","doc":"Roughly checks if the given binary has the form of a valid e-mail address using a not fully RFC-compliant regular expression taken from https://html.spec.whatwg.org/multipage/input.html#e-mail-state-(type=email) Examples iex&gt; VistaClient.quickcheck_email_address(123) {:error, {:invalid, [email: 123]}} iex&gt; VistaClient.quickcheck_email_address(&quot;foo@bar.baz&quot;) {:ok, &quot;foo@bar.baz&quot;} iex&gt; VistaClient.quickcheck_email_address(&quot;dash.is.not@-allowed.everywhere&quot;) {:error, {:invalid, [email: &quot;dash.is.not@-allowed.everywhere&quot;]}}"},{"ref":"VistaClient.html#start_external_payment/1","title":"VistaClient.start_external_payment/1","type":"function","doc":""},{"ref":"VistaClient.html#url_for/2","title":"VistaClient.url_for/2","type":"function","doc":""},{"ref":"VistaClient.html#validate_member/2","title":"VistaClient.validate_member/2","type":"function","doc":""},{"ref":"VistaClient.html#t:command/0","title":"VistaClient.command/0","type":"type","doc":""},{"ref":"VistaClient.html#t:headers/0","title":"VistaClient.headers/0","type":"type","doc":""},{"ref":"VistaClient.html#t:payload/0","title":"VistaClient.payload/0","type":"type","doc":""},{"ref":"VistaClient.html#t:reason/0","title":"VistaClient.reason/0","type":"type","doc":""},{"ref":"VistaClient.html#t:retrieved_entity/0","title":"VistaClient.retrieved_entity/0","type":"type","doc":""},{"ref":"VistaClient.html#t:url/0","title":"VistaClient.url/0","type":"type","doc":""},{"ref":"VistaClient.Behaviour.html","title":"VistaClient.Behaviour","type":"behaviour","doc":""},{"ref":"VistaClient.Behaviour.html#c:get_cinemas/0","title":"VistaClient.Behaviour.get_cinemas/0","type":"callback","doc":""},{"ref":"VistaClient.Behaviour.html#c:get_scheduled_films/0","title":"VistaClient.Behaviour.get_scheduled_films/0","type":"callback","doc":""},{"ref":"VistaClient.Behaviour.html#c:get_session_availabilty/1","title":"VistaClient.Behaviour.get_session_availabilty/1","type":"callback","doc":""},{"ref":"VistaClient.Behaviour.html#c:get_sessions/0","title":"VistaClient.Behaviour.get_sessions/0","type":"callback","doc":""},{"ref":"VistaClient.Cinema.html","title":"VistaClient.Cinema","type":"module","doc":""},{"ref":"VistaClient.Cinema.html#from_map/1","title":"VistaClient.Cinema.from_map/1","type":"function","doc":""},{"ref":"VistaClient.Cinema.html#from_map_list/2","title":"VistaClient.Cinema.from_map_list/2","type":"function","doc":""},{"ref":"VistaClient.Cinema.html#handle_validity/3","title":"VistaClient.Cinema.handle_validity/3","type":"function","doc":""},{"ref":"VistaClient.Config.html","title":"VistaClient.Config","type":"module","doc":""},{"ref":"VistaClient.Config.html#get/0","title":"VistaClient.Config.get/0","type":"function","doc":"Returns a VistaClient.Config struct. It&#39;s here to have a place for retrieving the config from the environment. Until now, it&#39; hard-coded though. Examples iex&gt; VistaClient.Config.get() %VistaClient.Config{api_token: &#39;…&#39;, api_url: &#39;…&#39;}"},{"ref":"VistaClient.Endpoint.html","title":"VistaClient.Endpoint","type":"module","doc":""},{"ref":"VistaClient.Endpoint.html#from_map/1","title":"VistaClient.Endpoint.from_map/1","type":"function","doc":""},{"ref":"VistaClient.Endpoint.html#from_map_list/1","title":"VistaClient.Endpoint.from_map_list/1","type":"function","doc":""},{"ref":"VistaClient.Extractors.html","title":"VistaClient.Extractors","type":"module","doc":"Helper functions to extract and convert certain attributes from a parsed JSOM map. For example, IDs are transmitted as strings by VISTA, so we&#39;re converting them to integers. Synopsis iex&gt; VistaClient.Extractors.extract_id %{&quot;ID&quot; =&gt; &quot;1001&quot;} {:ok, 1001} iex&gt; VistaClient.Extractors.extract_id %{&quot;id&quot; =&gt; 1001} {:error, :unparsable_id}"},{"ref":"VistaClient.Extractors.html#extract_attributes/1","title":"VistaClient.Extractors.extract_attributes/1","type":"function","doc":"Given the &quot;SessionAttributesNames&quot; field fron a Session map, takes the list and returns a tuple containing the attributes as in there and a version string. The version string is the attribute with highest priority in the list of known version attributes. Unknown attributes will be discarded."},{"ref":"VistaClient.Extractors.html#extract_date/1","title":"VistaClient.Extractors.extract_date/1","type":"function","doc":""},{"ref":"VistaClient.Extractors.html#extract_date/2","title":"VistaClient.Extractors.extract_date/2","type":"function","doc":"Naive string-to-datetime conversion. Assumes lack of timezone info. Examples iex&gt; Elixir.VistaClient.Extractors.extract_date(&quot;2019-02-26T20:00:00&quot;) {:ok, ~D[2019-02-26]}"},{"ref":"VistaClient.Extractors.html#extract_datetime/1","title":"VistaClient.Extractors.extract_datetime/1","type":"function","doc":""},{"ref":"VistaClient.Extractors.html#extract_datetime/2","title":"VistaClient.Extractors.extract_datetime/2","type":"function","doc":"Naive string-to-datetime conversion. Assumes lack of timezone info. Examples iex&gt; Elixir.VistaClient.Extractors.extract_datetime(&quot;2019-02-26T20:00:00&quot;) {:ok, ~N[2019-02-26 20:00:00]}"},{"ref":"VistaClient.Extractors.html#extract_id/2","title":"VistaClient.Extractors.extract_id/2","type":"function","doc":"Extracts the id from a map with an &quot;ID&quot; field containing an ID string"},{"ref":"VistaClient.Extractors.html#t:attributes/0","title":"VistaClient.Extractors.attributes/0","type":"type","doc":""},{"ref":"VistaClient.Extractors.html#t:id/0","title":"VistaClient.Extractors.id/0","type":"type","doc":""},{"ref":"VistaClient.Extractors.html#t:map_with_atttrs/0","title":"VistaClient.Extractors.map_with_atttrs/0","type":"type","doc":""},{"ref":"VistaClient.Extractors.html#t:map_with_id/0","title":"VistaClient.Extractors.map_with_id/0","type":"type","doc":""},{"ref":"VistaClient.Extractors.html#t:version/0","title":"VistaClient.Extractors.version/0","type":"type","doc":""},{"ref":"VistaClient.Film.html","title":"VistaClient.Film","type":"module","doc":""},{"ref":"VistaClient.Film.html#from_map/1","title":"VistaClient.Film.from_map/1","type":"function","doc":""},{"ref":"VistaClient.Film.html#from_map_list/2","title":"VistaClient.Film.from_map_list/2","type":"function","doc":""},{"ref":"VistaClient.Film.html#handle_validity/3","title":"VistaClient.Film.handle_validity/3","type":"function","doc":""},{"ref":"VistaClient.Film.html#transform_name/1","title":"VistaClient.Film.transform_name/1","type":"function","doc":"Gets real film names from sortable names with trailing pronouns. Works with German and English pronouns. Examples iex&gt; VistaClient.Film.transform_name(&quot;great Escape, The&quot;) &quot;The great Escape&quot; iex&gt; VistaClient.Film.transform_name(&quot;große Flucht, Die&quot;) &quot;Die große Flucht&quot;"},{"ref":"VistaClient.Film.html#transform_rating/1","title":"VistaClient.Film.transform_rating/1","type":"function","doc":""},{"ref":"VistaClient.Pluggable.html","title":"VistaClient.Pluggable","type":"module","doc":"TODO: evaluate/use Tesla to make HTTP requests for usage of simple plugs for composability."},{"ref":"VistaClient.Pluggable.html#delete/3","title":"VistaClient.Pluggable.delete/3","type":"function","doc":"Perform a DELETE request. See request/1 or request/2 for options definition. delete(&quot;/users&quot;) delete(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) delete(client, &quot;/users&quot;) delete(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"VistaClient.Pluggable.html#delete!/3","title":"VistaClient.Pluggable.delete!/3","type":"function","doc":"Perform a DELETE request. See request!/1 or request!/2 for options definition. delete!(&quot;/users&quot;) delete!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) delete!(client, &quot;/users&quot;) delete!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"VistaClient.Pluggable.html#get/3","title":"VistaClient.Pluggable.get/3","type":"function","doc":"Perform a GET request. See request/1 or request/2 for options definition. get(&quot;/users&quot;) get(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) get(client, &quot;/users&quot;) get(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"VistaClient.Pluggable.html#get!/3","title":"VistaClient.Pluggable.get!/3","type":"function","doc":"Perform a GET request. See request!/1 or request!/2 for options definition. get!(&quot;/users&quot;) get!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) get!(client, &quot;/users&quot;) get!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"VistaClient.Pluggable.html#get_session_availabilty/1","title":"VistaClient.Pluggable.get_session_availabilty/1","type":"function","doc":""},{"ref":"VistaClient.Pluggable.html#head/3","title":"VistaClient.Pluggable.head/3","type":"function","doc":"Perform a HEAD request. See request/1 or request/2 for options definition. head(&quot;/users&quot;) head(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) head(client, &quot;/users&quot;) head(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"VistaClient.Pluggable.html#head!/3","title":"VistaClient.Pluggable.head!/3","type":"function","doc":"Perform a HEAD request. See request!/1 or request!/2 for options definition. head!(&quot;/users&quot;) head!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) head!(client, &quot;/users&quot;) head!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"VistaClient.Pluggable.html#options/3","title":"VistaClient.Pluggable.options/3","type":"function","doc":"Perform a OPTIONS request. See request/1 or request/2 for options definition. options(&quot;/users&quot;) options(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) options(client, &quot;/users&quot;) options(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"VistaClient.Pluggable.html#options!/3","title":"VistaClient.Pluggable.options!/3","type":"function","doc":"Perform a OPTIONS request. See request!/1 or request!/2 for options definition. options!(&quot;/users&quot;) options!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) options!(client, &quot;/users&quot;) options!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"VistaClient.Pluggable.html#patch/4","title":"VistaClient.Pluggable.patch/4","type":"function","doc":"Perform a PATCH request. See request/1 or request/2 for options definition. patch(&quot;/users&quot;, %{name: &quot;Jon&quot;}) patch(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) patch(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) patch(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"VistaClient.Pluggable.html#patch!/4","title":"VistaClient.Pluggable.patch!/4","type":"function","doc":"Perform a PATCH request. See request!/1 or request!/2 for options definition. patch!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) patch!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) patch!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) patch!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"VistaClient.Pluggable.html#post/4","title":"VistaClient.Pluggable.post/4","type":"function","doc":"Perform a POST request. See request/1 or request/2 for options definition. post(&quot;/users&quot;, %{name: &quot;Jon&quot;}) post(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"VistaClient.Pluggable.html#post!/4","title":"VistaClient.Pluggable.post!/4","type":"function","doc":"Perform a POST request. See request!/1 or request!/2 for options definition. post!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) post!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) post!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) post!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"VistaClient.Pluggable.html#put/4","title":"VistaClient.Pluggable.put/4","type":"function","doc":"Perform a PUT request. See request/1 or request/2 for options definition. put(&quot;/users&quot;, %{name: &quot;Jon&quot;}) put(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) put(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) put(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"VistaClient.Pluggable.html#put!/4","title":"VistaClient.Pluggable.put!/4","type":"function","doc":"Perform a PUT request. See request!/1 or request!/2 for options definition. put!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) put!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) put!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) put!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"VistaClient.Pluggable.html#request/2","title":"VistaClient.Pluggable.request/2","type":"function","doc":"Perform a request Options: :method - the request method, one of [:head, :get, :delete, :trace, :options, :post, :put, :patch] :url - either full url e.g. &quot;http://example.com/some/path&quot; or just &quot;/some/path&quot; if using Tesla.Middleware.BaseUrl :query - a keyword list of query params, e.g. [page: 1, per_page: 100] :headers - a keyworld list of headers, e.g. [{&quot;content-type&quot;, &quot;text/plain&quot;}] :body - depends on used middleware: by default it can be a binary if using e.g. JSON encoding middleware it can be a nested map if adapter supports it it can be a Stream with any of the above :opts - custom, per-request middleware or adapter options Examples: ExampleApi.request(method: :get, url: &quot;/users/path&quot;) You can also use shortcut methods like: ExampleApi.get(&quot;/users/1&quot;) or ExampleApi.post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;})"},{"ref":"VistaClient.Pluggable.html#request!/2","title":"VistaClient.Pluggable.request!/2","type":"function","doc":"Perform request and raise in case of error. This is similar to request/2 behaviour from Tesla 0.x See request/2 for list of available options."},{"ref":"VistaClient.Pluggable.html#trace/3","title":"VistaClient.Pluggable.trace/3","type":"function","doc":"Perform a TRACE request. See request/1 or request/2 for options definition. trace(&quot;/users&quot;) trace(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) trace(client, &quot;/users&quot;) trace(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"VistaClient.Pluggable.html#trace!/3","title":"VistaClient.Pluggable.trace!/3","type":"function","doc":"Perform a TRACE request. See request!/1 or request!/2 for options definition. trace!(&quot;/users&quot;) trace!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) trace!(client, &quot;/users&quot;) trace!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"VistaClient.Pluggable.html#t:option/0","title":"VistaClient.Pluggable.option/0","type":"type","doc":""},{"ref":"VistaClient.Random.html","title":"VistaClient.Random","type":"module","doc":"Helper to generate random strings."},{"ref":"VistaClient.Random.html#string/1","title":"VistaClient.Random.string/1","type":"function","doc":"Example iex&gt; VistaClient.Random.string() &quot;a1wvjFLn6TQ4CTtz&quot; iex&gt; VistaClient.Random.string(32) &quot;jLFFKQv4Gh9QtxIl4FCepoQJwGkI87RI&quot;"},{"ref":"VistaClient.Session.html","title":"VistaClient.Session","type":"module","doc":"Struct to represent an Session. Definition Sessions A scrrening show of a film in a cinema on a screen at a certain time. This is what people book tickets for. JSON example: { &quot;ID&quot;: &quot;1001-14164&quot;, &quot;CinemaId&quot;: &quot;1001&quot;, &quot;ScheduledFilmId&quot;: &quot;HO00000720&quot;, &quot;SessionId&quot;: &quot;14164&quot;, &quot;AreaCategoryCodes&quot;: [], &quot;Showtime&quot;: &quot;2019-02-26T20:00:00&quot;, &quot;IsAllocatedSeating&quot;: false, &quot;AllowChildAdmits&quot;: true, &quot;SeatsAvailable&quot;: 66, &quot;AllowComplimentaryTickets&quot;: true, &quot;EventId&quot;: &quot;&quot;, &quot;PriceGroupCode&quot;: &quot;0033&quot;, &quot;ScreenName&quot;: &quot;Kino 2&quot;, &quot;ScreenNameAlt&quot;: &quot;433402&quot;, &quot;ScreenNumber&quot;: 2, &quot;CinemaOperatorCode&quot;: &quot;1001&quot;, &quot;FormatCode&quot;: &quot;0000000001&quot;, &quot;FormatHOPK&quot;: &quot;0000000001&quot;, &quot;SalesChannels&quot;: &quot;;CALL;RSP;GSALE;CELL;KIOSK;PDA;WWW;POSBK;POS;IVR;&quot;, &quot;SessionAttributesNames&quot;: [&quot;OV&quot;], &quot;ConceptAttributesNames&quot;: [], &quot;AllowTicketSales&quot;: true, &quot;HasDynamicallyPricedTicketsAvailable&quot;: false, &quot;PlayThroughId&quot;: null, &quot;SessionBusinessDate&quot;: &quot;2019-02-26T00:00:00&quot;, &quot;SessionDisplayPriority&quot;: 0, &quot;GroupSessionsByAttribute&quot;: false, &quot;SoldoutStatus&quot;: 0, &quot;TypeCode&quot;: &quot;N&quot; }"},{"ref":"VistaClient.Session.html#from_map/1","title":"VistaClient.Session.from_map/1","type":"function","doc":""},{"ref":"VistaClient.Session.html#from_map_list/2","title":"VistaClient.Session.from_map_list/2","type":"function","doc":""},{"ref":"VistaClient.Session.html#handle_validity/3","title":"VistaClient.Session.handle_validity/3","type":"function","doc":""},{"ref":"VistaClient.Session.html#showing_in/1","title":"VistaClient.Session.showing_in/1","type":"function","doc":"Takes a session and returns the seconds until the screening starts. Can be negative (session already started or has run Depends on erlang.localtime to be correct #FIXME: Abandon Naive DateTime Let&#39;s abandon localtimes and naive datettimes and just use UTC passing DateTime structs around."},{"ref":"VistaClient.SessionAvailability.html","title":"VistaClient.SessionAvailability","type":"module","doc":""},{"ref":"VistaClient.SessionAvailability.html#from_map/1","title":"VistaClient.SessionAvailability.from_map/1","type":"function","doc":"Serves as typed integer for seat availability. (Sometimes, Haskell-style types would be cool)."},{"ref":"VistaClient.SessionAvailability.html#from_map_list/2","title":"VistaClient.SessionAvailability.from_map_list/2","type":"function","doc":""},{"ref":"VistaClient.SessionAvailability.html#handle_validity/3","title":"VistaClient.SessionAvailability.handle_validity/3","type":"function","doc":""},{"ref":"VistaClient.Transformations.html","title":"VistaClient.Transformations","type":"module","doc":""},{"ref":"VistaClient.Transformations.html#get_films_sessions_for_day/3","title":"VistaClient.Transformations.get_films_sessions_for_day/3","type":"function","doc":""},{"ref":"VistaClient.Transformations.html#get_films_sessions_for_week/3","title":"VistaClient.Transformations.get_films_sessions_for_week/3","type":"function","doc":""},{"ref":"VistaClient.Transformations.html#to_serializable/2","title":"VistaClient.Transformations.to_serializable/2","type":"function","doc":""},{"ref":"VistaClient.Transformations.html#t:cinema_id/0","title":"VistaClient.Transformations.cinema_id/0","type":"type","doc":""},{"ref":"VistaClient.Transformations.html#t:day/0","title":"VistaClient.Transformations.day/0","type":"type","doc":""},{"ref":"VistaClient.Transformations.html#t:day_result/0","title":"VistaClient.Transformations.day_result/0","type":"type","doc":""},{"ref":"VistaClient.Transformations.html#t:film/0","title":"VistaClient.Transformations.film/0","type":"type","doc":""},{"ref":"VistaClient.Transformations.html#t:films/0","title":"VistaClient.Transformations.films/0","type":"type","doc":""},{"ref":"VistaClient.Transformations.html#t:filter/0","title":"VistaClient.Transformations.filter/0","type":"type","doc":""},{"ref":"VistaClient.Transformations.html#t:sessions/0","title":"VistaClient.Transformations.sessions/0","type":"type","doc":""},{"ref":"VistaClient.Transformations.html#t:week_result/0","title":"VistaClient.Transformations.week_result/0","type":"type","doc":""},{"ref":"VistaClient.Transformations.Filters.html","title":"VistaClient.Transformations.Filters","type":"module","doc":""},{"ref":"VistaClient.Transformations.Filters.Films.html","title":"VistaClient.Transformations.Filters.Films","type":"module","doc":""},{"ref":"VistaClient.Transformations.Filters.Films.html#get_by_id/2","title":"VistaClient.Transformations.Filters.Films.get_by_id/2","type":"function","doc":"Looks a film up by its id. This can be nil in case the film isn&#39;t found. This can happen when a film has been removed from the list of scheduled films but and this list was relaoded, but ther are (old) sessions are still referencing this film."},{"ref":"VistaClient.Transformations.Filters.Films.html#of_day/3","title":"VistaClient.Transformations.Filters.Films.of_day/3","type":"function","doc":""},{"ref":"VistaClient.Transformations.Filters.FilmsSessions.html","title":"VistaClient.Transformations.Filters.FilmsSessions","type":"module","doc":""},{"ref":"VistaClient.Transformations.Filters.FilmsSessions.html#filter_films_sessions/2","title":"VistaClient.Transformations.Filters.FilmsSessions.filter_films_sessions/2","type":"function","doc":""},{"ref":"VistaClient.Transformations.Filters.FilmsSessions.html#filter_started/2","title":"VistaClient.Transformations.Filters.FilmsSessions.filter_started/2","type":"function","doc":"Takes a list of film_sessions and returns same list with all sessions that have started already (specified as cutoff_date_time) filtered out."},{"ref":"VistaClient.Transformations.Filters.FilmsSessions.html#filter_started_30mins/1","title":"VistaClient.Transformations.Filters.FilmsSessions.filter_started_30mins/1","type":"function","doc":""},{"ref":"VistaClient.Transformations.Filters.FilmsSessions.html#session_expired?/2","title":"VistaClient.Transformations.Filters.FilmsSessions.session_expired?/2","type":"function","doc":"Compares session&#39;s showtime with cutoff_datetime. Returns true if showtime is after cutoff_datetime. Examples iex&gt; session = %Session{showtime: &quot;2019-03-21 12:20:00.00000Z&quot; |&gt; NaiveDateTime.fromiso8601} iex&gt; cutoffdatetime = &quot;2019-03-21 12:20:00.00000Z&quot; |&gt; DateTime.from_iso8601() |&gt; elem(1) iex&gt; __MODULE.session_expired?(session, cutoff_datetime) false iex&gt; session = %Session{showtime: &quot;2019-03-21 12:20:00.00000Z&quot; |&gt; NaiveDateTime.fromiso8601} iex&gt; cutoffdatetime = &quot;2019-03-21 12:10:00.00000Z&quot; |&gt; DateTime.from_iso8601() |&gt; elem(1) iex&gt; __MODULE.session_expired?(session, cutoff_datetime) false"},{"ref":"VistaClient.Transformations.Filters.FilmsSessions.html#session_valid?/2","title":"VistaClient.Transformations.Filters.FilmsSessions.session_valid?/2","type":"function","doc":""},{"ref":"VistaClient.Transformations.Filters.Sessions.html","title":"VistaClient.Transformations.Filters.Sessions","type":"module","doc":""},{"ref":"VistaClient.Transformations.Filters.Sessions.html#of_cinema/2","title":"VistaClient.Transformations.Filters.Sessions.of_cinema/2","type":"function","doc":""},{"ref":"VistaClient.Transformations.Filters.Sessions.html#of_day/2","title":"VistaClient.Transformations.Filters.Sessions.of_day/2","type":"function","doc":""},{"ref":"VistaClient.Transformations.Filters.Sessions.html#of_days/2","title":"VistaClient.Transformations.Filters.Sessions.of_days/2","type":"function","doc":""},{"ref":"VistaClient.Transformations.Filters.Sessions.html#of_film/2","title":"VistaClient.Transformations.Filters.Sessions.of_film/2","type":"function","doc":""},{"ref":"VistaClient.Transformations.Filters.Sessions.html#sort/1","title":"VistaClient.Transformations.Filters.Sessions.sort/1","type":"function","doc":""},{"ref":"VistaClient.Transformations.Serializer.html","title":"VistaClient.Transformations.Serializer","type":"module","doc":"Convert VistaClient&#39;s tuple-based internal data structures of &quot;films in a cinema on a day with their sessions&quot; and &quot;films in a cinema in a week with their sessions by day&quot; into Jason-digestible maps. Examples iex&gt; alias VistaClient.{Film,Session,Transformations} iex&gt; day_result = [{film, [session]}] = [{%Film{}, [%Session{}]}] iex&gt; Transformations.Serializer.from_day_result(day_result) [ %{ &quot;film&quot; =&gt; %VistaClient.Film{id: nil, name: nil, rating: nil}, &quot;sessions&quot; =&gt; [ %VistaClient.Session{ attributes: nil, cinema: nil, cinema_id: nil, date: nil, film: nil, film_id_string: nil, id_string: nil, showtime: nil, version: nil } ] } ] iex&gt; day = ~D[2019-01-01] iex&gt; week_result = [{film, [{day, [session]}]}] iex&gt; Transformations.Serializer.from_week_result(week_result) [ %{ &quot;days&quot; =&gt; %{ &quot;2019-01-01&quot; =&gt; [ %VistaClient.Session{attributes: nil, cinema: nil, cinema_id: nil, date: nil, film: nil, film_id_string: nil, id_string: nil, showtime: nil, version: nil} ] }, &quot;film&quot; =&gt; %VistaClient.Film{id: nil, name: nil, rating: nil} } ]"},{"ref":"VistaClient.Transformations.Serializer.html#from_day_result/1","title":"VistaClient.Transformations.Serializer.from_day_result/1","type":"function","doc":""},{"ref":"VistaClient.Transformations.Serializer.html#from_week_result/1","title":"VistaClient.Transformations.Serializer.from_week_result/1","type":"function","doc":""},{"ref":"VistaClient.Transformations.Setters.html","title":"VistaClient.Transformations.Setters","type":"module","doc":""},{"ref":"VistaClient.Transformations.Setters.html#set_cinema/2","title":"VistaClient.Transformations.Setters.set_cinema/2","type":"function","doc":""},{"ref":"VistaClient.Transformations.Setters.html#set_cinemas/2","title":"VistaClient.Transformations.Setters.set_cinemas/2","type":"function","doc":""},{"ref":"VistaClient.Transformations.Setters.html#set_film/2","title":"VistaClient.Transformations.Setters.set_film/2","type":"function","doc":""},{"ref":"VistaClient.Transformations.Setters.html#set_films/2","title":"VistaClient.Transformations.Setters.set_films/2","type":"function","doc":""},{"ref":"VistaClient.Transformations.Setters.html#t:cinema/0","title":"VistaClient.Transformations.Setters.cinema/0","type":"type","doc":""},{"ref":"VistaClient.Transformations.Setters.html#t:cinemas/0","title":"VistaClient.Transformations.Setters.cinemas/0","type":"type","doc":""},{"ref":"VistaClient.Transformations.Setters.html#t:film/0","title":"VistaClient.Transformations.Setters.film/0","type":"type","doc":""},{"ref":"VistaClient.Transformations.Setters.html#t:films/0","title":"VistaClient.Transformations.Setters.films/0","type":"type","doc":""},{"ref":"VistaClient.Transformations.Setters.html#t:session/0","title":"VistaClient.Transformations.Setters.session/0","type":"type","doc":""},{"ref":"VistaClient.Transformations.Setters.html#t:sessions/0","title":"VistaClient.Transformations.Setters.sessions/0","type":"type","doc":""}]